<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSpecialReqDetailsTypeSpecialRemark ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfSpecialReqDetailsTypeSpecialRemark extends AbstractStructArrayBase
{
    /**
     * The SpecialRemark
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgSpecialRemark[]
     */
    public $SpecialRemark;
    /**
     * Constructor method for ArrayOfSpecialReqDetailsTypeSpecialRemark
     * @uses DgArrayOfSpecialReqDetailsTypeSpecialRemark::setSpecialRemark()
     * @param \dgsoft\StructType\DgSpecialRemark[] $specialRemark
     */
    public function __construct(array $specialRemark = array())
    {
        $this
            ->setSpecialRemark($specialRemark);
    }
    /**
     * Get SpecialRemark value
     * @return \dgsoft\StructType\DgSpecialRemark[]|null
     */
    public function getSpecialRemark()
    {
        return $this->SpecialRemark;
    }
    /**
     * Set SpecialRemark value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgSpecialRemark[] $specialRemark
     * @return \dgsoft\ArrayType\DgArrayOfSpecialReqDetailsTypeSpecialRemark
     */
    public function setSpecialRemark(array $specialRemark = array())
    {
        foreach ($specialRemark as $arrayOfSpecialReqDetailsTypeSpecialRemarkSpecialRemarkItem) {
            // validation for constraint: itemType
            if (!$arrayOfSpecialReqDetailsTypeSpecialRemarkSpecialRemarkItem instanceof \dgsoft\StructType\DgSpecialRemark) {
                throw new \InvalidArgumentException(sprintf('The SpecialRemark property can only contain items of \dgsoft\StructType\DgSpecialRemark, "%s" given', is_object($arrayOfSpecialReqDetailsTypeSpecialRemarkSpecialRemarkItem) ? get_class($arrayOfSpecialReqDetailsTypeSpecialRemarkSpecialRemarkItem) : gettype($arrayOfSpecialReqDetailsTypeSpecialRemarkSpecialRemarkItem)), __LINE__);
            }
        }
        $this->SpecialRemark = $specialRemark;
        return $this;
    }
    /**
     * Add item to SpecialRemark value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgSpecialRemark $item
     * @return \dgsoft\ArrayType\DgArrayOfSpecialReqDetailsTypeSpecialRemark
     */
    public function addToSpecialRemark(\dgsoft\StructType\DgSpecialRemark $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgSpecialRemark) {
            throw new \InvalidArgumentException(sprintf('The SpecialRemark property can only contain items of \dgsoft\StructType\DgSpecialRemark, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->SpecialRemark[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgSpecialRemark|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgSpecialRemark|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgSpecialRemark|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgSpecialRemark|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgSpecialRemark|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SpecialRemark
     */
    public function getAttributeName()
    {
        return 'SpecialRemark';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfSpecialReqDetailsTypeSpecialRemark
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
